using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Grouping;
using Syncfusion.Collections;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace forums
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.Windows.Forms.Panel panel1;
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			// GroupingEngineFactory provides a modified GridChildTable that adds an extra section
			GridEngineFactory.Factory = new GroupingEngineFactory();

			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InitializeGridControl();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.panel1 = new System.Windows.Forms.Panel();
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(32, 40);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(448, 568);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.101.0.1";
			// 
			// panel1
			// 
			this.panel1.BackColor = System.Drawing.Color.White;
			this.panel1.Controls.Add(this.gridControl1);
			this.panel1.Location = new System.Drawing.Point(16, 256);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(432, 104);
			this.panel1.TabIndex = 1;
			// 
			// gridControl1
			// 
			this.gridControl1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridControl1.IgnoreCurrentCellInvalidate = false;
			this.gridControl1.Location = new System.Drawing.Point(0, 0);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.Size = new System.Drawing.Size(432, 104);
			this.gridControl1.SmartSizeBox = false;
			this.gridControl1.TabIndex = 0;
			this.gridControl1.Text = "gridControl1";
			this.gridControl1.QueryColWidth += new Syncfusion.Windows.Forms.Grid.GridRowColSizeEventHandler(this.gridControl1_QueryColWidth);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(512, 630);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.panel1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.gridGroupingControl1.TableModel.Options.WrapCellBehavior = GridWrapCellBehavior.WrapRow;
			
			DataTable parentTable = GetParentTable();
			DataTable childTable = GetChildTable();
			DataTable grandChildTable = GetGrandChildTable();

			DataSet ds = new DataSet();
			ds.Tables.AddRange(new DataTable[]{parentTable, childTable, grandChildTable});

			DataRelation parentToChild = new DataRelation("ParentToChild", parentTable.Columns["parentID"], childTable.Columns["ParentID"]);
			DataRelation childToGrandChild = new DataRelation("ChildToGrandChild", childTable.Columns["childID"], grandChildTable.Columns["ChildID"]);

			ds.Relations.AddRange(new DataRelation[]{parentToChild, childToGrandChild });

			this.gridGroupingControl1.DataSource = parentTable;
			this.gridGroupingControl1.ShowGroupDropArea = true;
			this.gridGroupingControl1.TopLevelGroupOptions.ShowCaption = false;

			this.gridGroupingControl1.TableModel.QueryCoveredRange += new GridQueryCoveredRangeEventHandler(TableModel_QueryCoveredRange);
			this.gridGroupingControl1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);
			this.gridGroupingControl1.TableDescriptor.GroupedColumns.Changed += new Syncfusion.Collections.ListPropertyChangedEventHandler(GroupedColumns_Changed);  

			this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add("ParentName");
			this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add("parentID");
			this.gridGroupingControl1.Table.ExpandAllRecords();
			check();
		}

		#region DataTables

		private int numberParentRows = 5;
		private int numberChildRows = 20;
		private int numberGrandChildRows = 50;
		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("parentID")); //lower case p
			dt.Columns.Add(new DataColumn("ParentName"));
			dt.Columns.Add(new DataColumn("ParentDec"));

			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;//.ToString();
				dr[1] = string.Format("parentName{0}", i);
				dr[2] = string.Format("desc{0}", i);
				dt.Rows.Add(dr);
			}

			return dt;
		}

		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable");

			dt.Columns.Add(new DataColumn("childID")); //lower case c
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ParentID")); //upper case P
			dt.Columns.Add(new DataColumn("other")); //upper case P
			dt.Columns.Add(new DataColumn("otherx")); //upper case P
			
			for(int i = 0; i < numberChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("ChildName{0}",i);
				dr[2] = (i % numberParentRows).ToString();
				dr[3] = string.Format("other{0}",i);
				dr[4] = string.Format("otherx{0}",i);
				dt.Rows.Add(dr);
			}
		
			return dt;
		}

		private DataTable GetGrandChildTable()
		{
			DataTable dt = new DataTable("GrandChildTable");

			dt.Columns.Add(new DataColumn("GrandChildID"));
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ChildID")); //upper case C
			
			for(int i = 0; i < numberGrandChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("GrandChildName{0}",i);
				dr[2] = (i % numberChildRows).ToString();
				dt.Rows.Add(dr);
			}
			
			return dt;
		}
		#endregion
		private void InitializeGridControl()
		{
			this.gridControl1.ThemesEnabled = true;
			this.gridControl1.Properties.ColHeaders  = false;
			this.gridControl1.RowCount = 1;
			this.gridControl1[1,4].Text = "Covered";
			//this.gridControl1.CoveredRanges.Add(GridRangeInfo.Cells(1,3,1,4));			 
			//this.gridControl1.ColCount = this.gridGroupingControl1.TableModel.ColCount +2;
			this.gridControl1.HScrollBehavior = GridScrollbarMode.Disabled;
			this.gridControl1.VScrollBehavior = GridScrollbarMode.Disabled;
			this.gridControl1.Properties.BackgroundColor = Color.White;
			this.gridControl1.TableStyle.Borders.All = new GridBorder(GridBorderStyle.None);
		}

		private void check()
		{
			if(this.gridGroupingControl1.TableDescriptor.GroupedColumns.Count >0)
				this.gridControl1.ColCount += this.gridGroupingControl1.TableDescriptor.GroupedColumns.Count;
		}

		private void TableModel_QueryCoveredRange(object sender, GridQueryCoveredRangeEventArgs e)
		{
			GridTableModel tm = sender as GridTableModel;
			Element el = tm.Table.DisplayElements[e.RowIndex];
			if (el is ExtraSection)
			{
				e.Range = GridRangeInfo.Cells(e.RowIndex, 0, e.RowIndex, tm.ColCount);
				e.Handled = true;
			}
		}
		private void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			e.Style.CellTipText = e.TableCellIdentity.Info;

			if (e.TableCellIdentity.DisplayElement is ExtraSection)
			{
				e.Style.CellType = "Control";
				e.Style.Control = this.panel1;
			}
		}


		private void gridControl1_QueryColWidth(object sender, Syncfusion.Windows.Forms.Grid.GridRowColSizeEventArgs e)
		{
			e.Size = this.gridGroupingControl1.TableModel.ColWidths[e.Index];
			e.Handled = true;
		}

		private void GroupedColumns_Changed(object sender, Syncfusion.Collections.ListPropertyChangedEventArgs e)
		{
			if(e.Action==ListPropertyChangedType.Insert)
				this.gridControl1.ColCount++;
			else if(e.Action==ListPropertyChangedType.Remove)
				this.gridControl1.ColCount--;
		}
	}

	# region GroupingEngineFactory

	/// <summary>
	/// GroupingEngineFactory provides a trimmed down GridGroup
	/// which eliminates overhead of not needed preview rows, header and footer cells.
	/// </summary>
	public class GroupingEngineFactory : GridEngineFactoryBase
	{
		public override GridEngine CreateEngine()
		{
			return new GroupingEngine();
		}
	}

	public class GroupingEngine : GridEngine
	{
		public override ChildTable CreateChildTable(Element parent)
		{
			return new GroupingChildTable(parent);
		}
	}

	public class ExtraSection : EmptySection
	{
		public ExtraSection(Group parent)
			: base(parent)
		{
		}

		public override DisplayElementKind Kind
		{
			get { return DisplayElementKind.None; }
		}

		public override int GetElementCount()
		{
			return 1;
		}

		public override int GetVisibleCount()
		{
			return 1;
		}

		public override double GetYAmountCount()
		{
			return 20;
		}
	}

	public class GroupingChildTable : GridChildTable
	{
		public GroupingChildTable(Element parent)
			: base(parent)
		{
		}

		protected override void OnInitializeSections(bool hasRecords, SortColumnDescriptorCollection fields)
		{
			if (this.IsTopLevelGroup)
				this.Sections.Add(new ExtraSection(this));
			base.OnInitializeSections(hasRecords, fields);
		}

		public override bool IsChildVisible(Element el)
		{
			if (this.IsTopLevelGroup && el is ExtraSection)
			{
				return true;
			}
			else
				return base.IsChildVisible(el);
		}
	}
	# endregion
}
